<?php

use PrestaShop\PrestaShop\Adapter\ServiceLocator;

class Order extends OrderCore
{
    public static function generateReference()
    {
        $format = Configuration::get('refchange_format');
        if ($format == 0) {
            return strtoupper(Tools::passwdGen(9, 'NO_NUMERIC'));
        } elseif ($format == 1) {
            return self::generateRandomString(9, 1);
        } elseif ($format == 2) {
            return self::generateRandomString(9, 2);
        } elseif ($format == 3) {
            return self::generateRandomString(9, 3);
        } elseif ($format == 4) {
            return self::generateRandomString(9, 4);
        }
    }

    public static function generateRandomString($length = 9, $format = 1)
    {
        if ($format == 1) {
            $characters = '0123456789';
        } elseif ($format == 2) {
            $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        } elseif ($format == 3) {
            $characters = 'abcdefghijklmnopqrstuvwxyz';
        } elseif ($format == 4) {
            $characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        }

        $charactersLength = strlen($characters);
        $randomString = '';
        for ($i = 0; $i < $length; $i++) {
            $randomString .= $characters[rand(0, $charactersLength - 1)];
        }
        return $randomString;
    }
}

?>